Subject: bug#64442: 29.0.92; treesit-beginning-of-defun fails in DEFUN functions in C

From: Eli Zaretskii <[email-masked]>
Date: Sat, 12 Aug 2023 17:59:37 +0300

> From: Yuan Fu <[email-masked]>
> Date: Thu, 10 Aug 2023 14:33:09 -0700
> Cc: [email-masked]
> 
> I still don’t have a good solution. But I just realized that we might be able to make a little compromise: what if Emacs recognizes DEFUN, but as two separate parts (the declaration and the body), rather than one? It’s hard to make it recognize DEFUN as a single defun, but making it recognize DEFUN as two parts is easy.
> 
> Try this patch and see if you like the behavior. Personally I find it quite alright.

I like this much better than what we have now, thanks.  But I have a
question: can we perhaps recognize the "function" of the body as such,
and then automatically move to the previous defun, which is the right
place?  The "defun" that is the body has no name, so maybe that could
be used as a sign?  That would allow "C-x 4 a" to work inside a DEFUN,
something that still works less reliably with this patch: you must be
in the "first defun" to get it to find the name of the function.

But if improving this is hard, I'll settle for what you have now,
thanks a lot.